<?php
/*------------------------------------*/
/* OnlineControl for T-Sinus 1054 DSL */
/* (c) 2005 Rauch Webdesign           */
/* Licensed unter GPL v2 or later     */
/*------------------------------------*/
//IP-Adress of the T-Sinus 1054 DSL Router
$server = "192.168.0.254";
//Verzögerung bei Verbindungsauf- und Abbau in Millisekunden 
//Standard 2000000 = 2 Sekunden
$delay = 2000000;
//Status lesen
function OCgetStatus(){
	global $server,$page;
	$fp = fsockopen($server, 80, $errno, $errstr, 30);
	if (!$fp) {
		echo "$errstr ($errno)<br />\n";
	} else {
		$out = "GET /hcti_status_ocontrol.htm HTTP/1.1\r\n";
		$out .= "Host: ".$server."\r\n";
		$out .= "Connection: Close\r\n\r\n";
		fwrite($fp, $out);
		while (!feof($fp)) {
			$output[] = fgets($fp, 128);
			
		}
		fclose($fp);
	}
	//Angaben auslesen und Formatieren
	$page->ip = str_replace("var wan_ip=\"","",str_replace("\";\n","",$output[6]));
	$page->gateway = str_replace("var wan_gateway=\"","",str_replace("\";\n","",$output[8]));
	$page->ns1 = str_replace("var primary_dns=\"","",str_replace("\";\n","",$output[9]));
	$page->ns2 = str_replace("var secondary_dns=\"","",str_replace("\";\n","",$output[10]));
	if($output[5] == "var bWanConnected=0;\n"){
		$page->connected = "Nein";
	} elseif($output[5] == "var bWanConnected=1;\n"){
		$page->connected = "Ja";
	} else {
		$page->connected = "Unbekannt";
	}
}
//Verbindung aufbauen
function OCconnect(){
	global $server;
	$fp = fsockopen($server, 80, $errno, $errstr, 30);
	if (!$fp) {
		echo "$errstr ($errno)<br />\n";
	} else {
		$out = "GET /cgi-bin/connect.exe HTTP/1.1\r\n";
		$out .= "Host: ".$server."\r\n";
		$out .= "Connection: Close\r\n\r\n";
		fwrite($fp, $out);
		while (!feof($fp)) {
			$output[] = fgets($fp, 128);
			
		}
		fclose($fp);
	}
	return ($output);
}
//Verbindung trennen
function OCdisconnect(){
	global $server;
	$fp = fsockopen($server, 80, $errno, $errstr, 30);
	if (!$fp) {
		echo "$errstr ($errno)<br />\n";
	} else {
		$out = "GET /cgi-bin/disconnect.exe HTTP/1.1\r\n";
		$out .= "Host: ".$server."\r\n";
		$out .= "Connection: Close\r\n\r\n";
		fwrite($fp, $out);
		while (!feof($fp)) {
			$output[] = fgets($fp, 128);
			
		}
		fclose($fp);
	}
	return ($output);
}
//Verbinden?
if(isset($_POST['submit_connect'])){
	OCconnect();
	//Warten auf Verbindungsaufbau
 	usleep($delay);
//oder Trennen
} elseif(isset($_POST['submit_disconnect'])){
	OCdisconnect();
	//Warten auf Verbindungsabbau
	usleep($delay);
}
//Status abrufen
OCgetStatus();
?>
<HTML>
<HEAD>
	<TITLE>OnlineControl Status</TITLE>
	<meta http-equiv="refresh" content="5; URL=<?php echo "http://".$_SERVER['SERVER_ADDR'].$_SERVER['SCRIPT_NAME'] ?>">
</HEAD>
<BODY>
	<form method="POST">
	<TABLE border="1">
		<TR>
			<TD width="50%"><input type="submit" name="submit_connect" value="Verbinden"></TD>
			<TD width="50%"><input type="submit" name="submit_disconnect" value="Trennen"></TD>
		</TR>
		<TR>
			<TD>Verbunden:</TD>
			<TD><?php
				echo $page->connected;
			?></TD>
		</TR>
		<tr>
			<TD>IP-Adresse (extern)</TD>
			<TD><?php
				echo $page->ip;
			?></TD>
		</tr>
		<tr>
			<TD>Gateway</TD>
			<TD><?php
				echo $page->gateway;
			?></TD>
		</tr>
		<tr>
			<TD>Prim&#228;rer Nameserver</TD>
			<TD><?php
				echo $page->ns1;
			?></TD>
		</tr>
		<tr>
			<TD>Sekund&#228;rer Nameserver</TD>
			<TD><?php
				echo $page->ns2;
			?></TD>
		</tr>
	</TABLE>
	</form>
</BODY>
</HTML>